------------------------------------------------------------------------------
----------------------         M a R T E   O S         -----------------------
------------------------------------------------------------------------------
--                                                             V1.57  Dic 2005
--
--                    'K e r n e l . P o o l _ T C B s'
--
--                                 Body
--
--
--  File 'k-pool_tcbs.adb'                                            By MAR.
--
--
--  Free Task Control Blocks management.
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2004   Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael González Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
------------------------------------------------------------------------------

with Singly_Linked_Lists.Resources;
pragma Elaborate_All (Singly_Linked_Lists.Resources);
with Kernel;
pragma Elaborate_All (Kernel);

package body Kernel.Pool_TCBs is

   package TCBs_Mangement is new Tasks_Lists.Resources;

   Free_TCBs : array (TCBs_Range) of aliased Tasks_Lists.Element;
   --  'Num_Tasks_Mx' user's task (included the main) plus the idle and
   --  the signal handler tasks.

   procedure Release_TCB (T : in Task_Id) renames TCBs_Mangement.Release;

   function Request_TCB return Task_Id renames TCBs_Mangement.Request;

   function Get_TCB_By_Number (Num : TCBs_Range) return Task_Id is
   begin
      return Free_TCBs (Num)'Access;
   end Get_TCB_By_Number;

begin
   --  Initialize 'Free_TCBs'
   --  Free_TCBs(0) -> Main Task
   --  Free_TCBs(Num_Tasks_Mx) -> Idle Task
   --  Free_TCBs(Num_Tasks_Mx + 1) -> Signal Handler Task
   for I in Normal_Tasks_TCBs_Range loop
      Release_TCB (Free_TCBs (I)'Access);
   end loop;
end Kernel.Pool_TCBs;
