------------------------------------------------------------------------------
--  ------------------         M a R T E   O S         -------------------  --
------------------------------------------------------------------------------
--                                                             V1.57  Dic 2005
--
--              'K e r n e l . T i m e r s . I n t e r n a l s'
--
--                                 Spec
--
--
--  File 'k-timers-internals.ads'                                      By MAR.
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2004   Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael González Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
-------------------------------------------------------------------------------
with Hardware_Interface;

package Kernel.Timers.Internals is

   package HWI  renames Hardware_Interface;

   function Is_CPU_Clock_Of_Self (Clock : Clock_Id) return Boolean;
   pragma Inline (Is_CPU_Clock_Of_Self);

   function Clock_Id_OK (Clock : Clock_Id) return Boolean;
   pragma Inline (Clock_Id_OK);


   function Timer_Id_OK (Timer : Timer_Id) return Boolean;
   pragma Inline (Timer_Id_OK);


   procedure Timer_Expired (Timer : in Timer_Id; At_Time : in HWI.HWTime);
   pragma Inline (Timer_Expired);


   procedure Disarm_Timer (Timer : in Timer_Id);
   pragma Inline (Disarm_Timer);


   procedure Arm_Timer (Timer     : in  Timer_Id;
                        Options   : in  Timer_Options;
                        New_State : in  Timer_State;
                        Now       : in  HWI.HWTime);
   pragma Inline (Arm_Timer);


   function Get_Timer_State (Timer : Timer_Id;
                             Now : HWI.HWTime) return Timer_State;
   pragma Inline (Get_Timer_State);

end Kernel.Timers.Internals;
