------------------------------------------------------------------------------
--  ------------------         M a R T E   O S         -------------------  --
------------------------------------------------------------------------------
--                                                             V1.57  Dic 2005
--
--         'S i n g l y _ L i n k e d _ L i s t s . R e s o u r c e s'
--
--                                  Spec
--
--
--  File 'sll-resources.ads'                                           by Mar.
--
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2004   Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael González Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
-------------------------------------------------------------------------------
generic
package Singly_Linked_Lists.Resources is

   procedure Release (R : in Element_Ac);
   pragma Inline (Release);

   type Basic_Ac is access constant Basic;
   procedure Release (Value : in Basic_Ac;
                      R     : in Element_Ac);
   pragma Inline (Release);

   function Request return Element_Ac;
   pragma Inline (Request);

   procedure Assign_Resources (Resources : in List);
   pragma Inline (Assign_Resources);

   function Resources_Left return Boolean;
   pragma Inline (Resources_Left);

end Singly_Linked_Lists.Resources;
