/*----------------------------------------------------------------------------
 *-- -------------------         M a R T E   O S         ------------------ --
 *----------------------------------------------------------------------------
 *                                                             V1.57  Dic 2005
 *
 *                         'd r i v e r s _ m a r t e'
 *
 *                                      H
 *
 * File 'drivers_marte.h'                                       by Fguerreira
 *
 *
 *  ----------------------------------------------------------------------
 *   Copyright (C) 2004   Universidad de Cantabria, SPAIN
 *
 *   MaRTE OS web page: http://marte.unican.es
 *   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
 *                      Michael González Harbour      mgh@unican.es
 *
 *  MaRTE OS  is free software; you can  redistribute it and/or  modify it
 *  under the terms of the GNU General Public License  as published by the
 *  Free Software Foundation;  either  version 2, or (at  your option) any
 *  later version.
 *
 *  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
 *  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 *  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 *  General Public License for more details.
 *
 *  You should have received  a  copy of  the  GNU General Public  License
 *  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
 *  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 *  02111-1307, USA.
 *
 *  As a  special exception, if you  link this  unit  with other  files to
 *  produce an   executable,   this unit  does  not  by  itself cause  the
 *  resulting executable to be covered by the  GNU General Public License.
 *  This exception does  not however invalidate  any other reasons why the
 *  executable file might be covered by the GNU Public License.
 *
 *---------------------------------------------------------------------------*/

#ifndef _DRIVERS_MARTE_H_
#define _DRIVERS_MARTE_H_
#include <pthread.h>

/* Gets the major number */
int get_major (int filedes);

/* Gets the minor number */
int get_minor (int filedes);

/* Gets specific data */
int driver_getspecific (int filedes, int *data);

int driver_setspecific (int filedes, int data);

/* Gets the mutex associated with the file descriptor */
pthread_mutex_t *get_mutex (int filedes);

#endif /* _DRIVERS_MARTE_H_ */

